# TODO: build current htmlman (make -C doc htmlman/index.html, requires hevea and hacha)
#
# Conditional build:
%bcond_without	ocaml_opt	# native optimized binaries (bytecode is always built)

# not yet available on x32 (ocaml 4.02.1), update when upstream will support it
%ifnarch %{ix86} %{x8664} %{arm} aarch64 ppc sparc sparcv9
%undefine	with_ocaml_opt
%endif

Summary:	CamlIDL - stub code generator and COM binding for OCaml
Summary(pl.UTF-8):	CamlIDL - generator kodu zaślepek oraz wiązania COM dla OCamla
%define	shortversion	%(echo %{version} | tr -d .)
Name:		ocaml-idl
Version:	1.09
Release:	5
License:	QPL v1.0 (compiler), LGPL v2 (library)
Group:		Libraries
#Source0Download: https://github.com/xavierleroy/camlidl/releases
Source0:	https://github.com/xavierleroy/camlidl/archive/camlidl%{shortversion}/camlidl-%{version}.tar.gz
# Source0-md5:	50a7348c14ce7448a35efa96b98018af
Source1:	http://caml.inria.fr/distrib/bazar-ocaml/camlidl-1.05.doc.html.tar.gz
# Source1-md5:	b7c7dad3ba62ddcc0f687bdebe295126
Patch0:		no-opt.patch
Patch1:		DESTDIR.patch
URL:		https://github.com/xavierleroy/camlidl
BuildRequires:	ocaml >= 1:4.03
Obsoletes:	ocaml-camlidl < 1.05-3
%requires_eq	ocaml-runtime
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Camlidl is a stub code generator for Objective Caml. It generates stub
code for interfacing Caml with C from an IDL description of the C
functions. Thus, Camlidl automates the most tedious task in
interfacing C libraries with Caml programs. It can also be used to
interface Caml programs with other languages, as long as those
languages have a well-defined C interface.

This package contains files needed to run bytecode executables using
this library.

%description -l pl.UTF-8
Camlidl jest generatorem kodu łączącego C z OCamlem. Pozwala on na
automatyczne tworzenie funkcji, które będą mogły być wywoływane z
OCamla na podstawie opisu IDL. Automatyzuje więc najbardziej
niewdzięczne aspekty odwoływania się do bibliotek napisanych w C z
OCamla. Może być również użyty do komunikacji z innymi językami, jeśli
tylko mają one dobrze zdefiniowany interfejs C.

Pakiet ten zawiera binaria potrzebne do uruchamiania programów
używających tej biblioteki.

%package devel
Summary:	IDL binding for OCaml - development part
Summary(pl.UTF-8):	Wiązania IDL dla OCamla - cześć programistyczna
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
%requires_eq	ocaml

%description devel
Camlidl is a stub code generator for Objective Caml. It generates stub
code for interfacing Caml with C from an IDL description of the C
functions. Thus, Camlidl automates the most tedious task in
interfacing C libraries with Caml programs. It can also be used to
interface Caml programs with other languages, as long as those
languages have a well-defined C interface.

This package contains files needed to develop OCaml programs using
this library.

%description devel -l pl.UTF-8
Camlidl jest generatorem kodu łączącego C z OCamlem. Pozwala on na
automatyczne tworzenie funkcji, które będą mogły być wywoływane z
OCamla na podstawie opisu IDL. Automatyzuje więc najbardziej
niewdzięczne aspekty odwoływania się do bibliotek napisanych w C z
OCamla. Może być również użyty do komunikacji z innymi językami, jeśli
tylko mają one dobrze zdefiniowany interfejs C.

Pakiet ten zawiera pliki niezbędne do tworzenia programów używających
tej biblioteki.

%prep
%setup -q -a 1 -n camlidl-camlidl%{shortversion}
%patch0 -p1
%patch1 -p1

ln -s Makefile.unix config/Makefile

%build
%{__make} -j1 -C compiler \
	CPP="%{__cc} -E -x c" \
	CFLAGS="%{rpmcflags} -fPIC"

%{__make} -j1 -C lib com.cma %{?with_ocaml_opt:com.cmxa} \
	CPP="%{__cc} -E -x c" \
	CFLAGS="%{rpmcflags} -fPIC"

%{__make} -j1 -C runtime \
	CPP="%{__cc} -E -x c" \
	CFLAGS="%{rpmcflags} -fPIC"

%{__make} -j1 -C tools \
	CPP="%{__cc} -E -x c" \
	CFLAGS="%{rpmcflags} -fPIC"

# create dllcom.so (is it still required?)
ocamlmklib -o com lib/*.cm[xo] runtime/*.o

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_bindir},%{_libdir}/ocaml/{stublibs,idl},%{_includedir}/caml}
# header is installed via this symlink
ln -sf ../../include/caml $RPM_BUILD_ROOT%{_libdir}/ocaml/caml

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT \
	BINDIR=%{_bindir} \
	OCAMLLIB=%{_libdir}/ocaml \
	%{!?with_ocaml_opt:NATIVELIB=""}

# fix install to subdir
%{__mv} $RPM_BUILD_ROOT%{_libdir}/ocaml/{*.{cm[ix],cma,a%{?with_ocaml_opt:,cmxa}},idl}

install -d $RPM_BUILD_ROOT%{_libdir}/ocaml/stublibs
install -p dll*.so $RPM_BUILD_ROOT%{_libdir}/ocaml/stublibs

install -d $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}
cp -a tests/* $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}
# remove Windows examples
%{__rm} -r $RPM_BUILD_ROOT%{_examplesdir}/%{name}-%{version}/{comp,dispatch}

cat > $RPM_BUILD_ROOT%{_libdir}/ocaml/idl/META <<EOF
requires = ""
version = "%{version}"
directory = "+idl"
archive(byte) = "com.cma"
archive(native) = "com.cmxa"
linkopts = ""
EOF
ln -sr $RPM_BUILD_ROOT%{_libdir}/ocaml/{idl,camlidl}

# symlink belongs to ocaml package
%{__rm} $RPM_BUILD_ROOT%{_libdir}/ocaml/caml

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc Changes LICENSE README
%dir %{_libdir}/ocaml/idl
%{_libdir}/ocaml/idl/META
%{_libdir}/ocaml/idl/com.cma
%attr(755,root,root) %{_libdir}/ocaml/stublibs/dllcamlidl.so
%attr(755,root,root) %{_libdir}/ocaml/stublibs/dllcom.so

%files devel
%defattr(644,root,root,755)
%doc htmlman
%attr(755,root,root) %{_bindir}/camlidl
# compat symlink
%{_libdir}/ocaml/camlidl
%{_libdir}/ocaml/idl/com.cmi
%if %{with ocaml_opt}
%{_libdir}/ocaml/idl/com.a
%{_libdir}/ocaml/idl/com.cmxa
%endif
%{_libdir}/ocaml/idl/libcamlidl.a
%{_includedir}/caml/camlidlruntime.h
%{_examplesdir}/%{name}-%{version}
%changelog
* Sat Nov 20 2021 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/ocaml-idl.git;a=log;h=master

* Sat Nov 20 2021 Jan Rękorajski <baggins@pld-linux.org> 462f78a
- rebuild with separate debuginfo build-ids

* Thu Sep 16 2021 Jakub Bogusz <qboosh@pld-linux.org> 661a7a0
- updated URL and ocaml version, packaging cleanups/updates

* Sat Mar 27 2021 Jan Rękorajski <baggins@pld-linux.org> 336763a
- update META file location
- rel 4

* Tue Mar 23 2021 Jan Rękorajski <baggins@pld-linux.org> c54b92e
- add dune symlink to files

* Tue Mar 23 2021 Jan Rękorajski <baggins@pld-linux.org> 42a8822
- add lib symlink for dune
- rel 3

* Tue Mar 23 2021 Jan Rękorajski <baggins@pld-linux.org> dbad7f8
- fix META install
- rel 2

* Tue Mar 23 2021 Jan Rękorajski <baggins@pld-linux.org> 5460b6a
- fix (no)opt files

* Tue Mar 23 2021 Jan Rękorajski <baggins@pld-linux.org> d06d8c5
- add missing patch

* Tue Mar 23 2021 Jan Rękorajski <baggins@pld-linux.org> 602c3e8
- up to 1.09

* Mon Jun 05 2017 Jan Rękorajski <baggins@pld-linux.org> 76c03e9
- OCaml 4.03 compatibility fix
- rel 14

* Mon Jun 05 2017 Jan Rękorajski <baggins@pld-linux.org> 3c8f58b
- rebuild with ocaml 4.04.1
- release 13 (by relup.sh)

* Fri Mar 18 2016 Jan Rękorajski <baggins@pld-linux.org> cc58d20
- release 12 (by relup.sh)

* Sun Jul 19 2015 Jakub Bogusz <qboosh@pld-linux.org> 0f71ee8
- verbose files, release 11 (ocaml rebuild)

* Mon Apr 06 2015 Jan Rękorajski <baggins@pld-linux.org> ace9ac3
- fixed install without opt

* Mon Apr 06 2015 Jan Rękorajski <baggins@pld-linux.org> e1dabfa
- fixed no-opt patch
- rel 10

* Mon Apr 06 2015 Jan Rękorajski <baggins@pld-linux.org> ff869cf
- added ocaml_opt patch
- rel 9

* Sun Nov 16 2014 Jan Rękorajski <baggins@pld-linux.org> 332177d
- rebuild with ocaml 4.02
- release 8 (by relup.sh)

* Sun Nov 24 2013 Elan Ruusamäe <glen@delfi.ee> 487fb0f
- merged changes from ocaml-camlidl; rel 7

* Tue Feb 13 2007 Elan Ruusamäe <glen@pld-linux.org> 703c2f1
- tabs in preamble

* Mon Feb 12 2007 Jan Rękorajski <baggins@pld-linux.org> eee7984
- converted to UTF-8

